import { createContext, useLayoutEffect, useState } from "react";

export const TaskContext = createContext(
  {
    tasks_ar:[{name:"",id:1}],
    showEdit:false,
    showEditPopup:() => {}, 
    hideEditPopup:() => {},
    addTask:(item) => {},
    removeTask:(id) => {}
  }
);


export function TaksContextProvider({children}){
  const [tasks_ar,setTasksAr] = useState([
    {name:"go to work", id:1},
    {name:"go to eat", id:2}
  ])
  const [showEdit,setShowEdit] = useState(false)

  useLayoutEffect(() => {
    if(localStorage.getItem("tasks")){
      setTasksAr(JSON.parse(localStorage.getItem("tasks")))
    }
  },[])

  const addTask = (item) => {
    setTasksAr((ar) => saveToLocal([...ar,item]));
    
  }

  const removeTask = (id) => {
    setTasksAr((ar) => saveToLocal(ar.filter(item => item.id != id)))
  }

  const saveToLocal = (newTask_ar) => {
    localStorage.setItem("tasks",JSON.stringify(newTask_ar))
    return newTask_ar;
  }

  const showEditPopup = () => {
    setShowEdit(true);
  }

  const hideEditPopup = () => {
    setShowEdit(false);
  }
 
  const val = {
    showEdit, showEditPopup, hideEditPopup,
    tasks_ar,
    addTask,
    removeTask
  }




  return (
    <TaskContext.Provider value={val} >
      {children}
    </TaskContext.Provider>
  )
}